Index: issm/trunk/src/m/classes/fourierlove.py
===================================================================
--- issm/trunk/src/m/classes/fourierlove.py	(revision 25994)
+++ issm/trunk/src/m/classes/fourierlove.py	(revision 26744)
@@ -1,2 +1,4 @@
+import numpy as np
+
 from fielddisplay import fielddisplay
 from checkfield import checkfield
@@ -5,11 +7,11 @@
 
 class fourierlove(object):
+    """FOURIERLOVE - class definition
+
+    Usage:
+        md.love = fourierlove()
     """
-    Fourier Love Number class definition
 
-       Usage:
-          fourierlove = fourierlove()
-    """
-    def __init__(self):  # {{{
+    def __init__(self): #{{{
         self.nfreq = 0
         self.frequencies = 0
@@ -19,80 +21,126 @@
         self.r0 = 0
         self.mu0 = 0
+        self.Gravitational_Constant = 0
         self.allow_layer_deletion = 0
+        self.underflow_tol = 0
+        self.integration_steps_per_layer = 0
+        self.istemporal = 0
+        self.n_temporal_iterations = 0
+        self.time = 0
         self.love_kernels = 0
         self.forcing_type = 0
+        self.inner_core_boundary = 0
+        self.core_mantle_boundary = 0
+        self.complex_computation = 0
 
-    #set defaults
         self.setdefaultparameters()
     #}}}
 
-    def __repr__(self):  # {{{
-        string = '   Fourier Love class:'
-        string = "%s\n%s" % (string, fielddisplay(self, 'nfreq', 'number of frequencies sampled (default 1, elastic) [Hz]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'frequencies', 'frequencies sampled (convention defaults to 0 for the elastic case) [Hz]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'sh_nmax', 'maximum spherical harmonic degree (default 256, .35 deg, or 40 km at equator)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'sh_nmin', 'minimum spherical harmonic degree (default 1)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'g0', 'adimensioning constant for gravity (default 10) [m / s^2]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'r0', 'adimensioning constant for radius (default 6378e3) [m]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'mu0', 'adimensioning constant for stress (default 1.0e11) [Pa]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'allow_layer_deletion', 'allow for migration of the integration boundary with increasing spherical harmonics degree (default 1)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'love_kernels', 'compute love numbers at depth? (default 0)'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'forcing_type', 'integer indicating the nature and depth of the forcing for the Love number calculation (default 11) :'))
-        string = "%s\n%s" % (string, '                                                     1:  Inner core boundary -- Volumic Potential')
-        string = "%s\n%s" % (string, '                                                     2:  Inner core boundary --  Pressure')
-        string = "%s\n%s" % (string, '                                                     3:  Inner core boundary --  Loading')
-        string = "%s\n%s" % (string, '                                                     4:  Inner core boundary --  Tangential traction')
-        string = "%s\n%s" % (string, '                                                     5:  Core mantle boundary --  Volumic Potential')
-        string = "%s\n%s" % (string, '                                                     6:  Core mantle boundary --  Pressure')
-        string = "%s\n%s" % (string, '                                                     7:  Core mantle boundary --  Loading')
-        string = "%s\n%s" % (string, '                                                     8:  Core mantle boundary --  Tangential traction')
-        string = "%s\n%s" % (string, '                                                     9:  Surface--  Volumic Potential')
-        string = "%s\n%s" % (string, '                                                     10: Surface--  Pressure')
-        string = "%s\n%s" % (string, '                                                     11: Surface--  Loading')
-        string = "%s\n%s" % (string, '                                                     12: Surface--  Tangential traction ')
+    def __repr__(self): #{{{
+        # TODO:
+        # - Correct display to match MATLAB
+        #
+        s = '   Fourier Love class:\n'
+        s += '{}\n'.format(fielddisplay(self, 'nfreq', 'number of frequencies sampled (default: 1, elastic) [Hz]'))
+        s += '{}\n'.format(fielddisplay(self, 'frequencies', 'frequencies sampled (convention defaults to 0 for the elastic case) [Hz]'))
+        s += '{}\n'.format(fielddisplay(self, 'sh_nmax', 'maximum spherical harmonic degree (default: 256, .35 deg, or 40 km at equator)'))
+        s += '{}\n'.format(fielddisplay(self, 'sh_nmin', 'minimum spherical harmonic degree (default: 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'g0', 'adimensioning constant for gravity (default: 10) [m/s^2]'))
+        s += '{}\n'.format(fielddisplay(self, 'r0', 'adimensioning constant for radius (default: 6371*10^3) [m]'))
+        s += '{}\n'.format(fielddisplay(self, 'mu0', 'adimensioning constant for stress (default: 10^11) [Pa]'))
+        s += '{}\n'.format(fielddisplay(self, 'allow_layer_deletion', 'allow for migration of the integration boundary with increasing spherical harmonics degree (default: 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'Gravitational_Constant', 'Newtonian constant of gravitation (default: 6.67259e-11 [m^3 kg^-1 s^-2])'))
+        s += '{}\n'.format(fielddisplay(self, 'allow_layer_deletion', 'allow for migration of the integration boundary with increasing spherical harmonics degree (default: 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'underflow_tol', 'threshold of deep to surface love number ratio to trigger the deletion of layers (default: 1e-16)'))
+        s += '{}\n'.format(fielddisplay(self, 'integration_steps_per_layer', 'number of radial steps to propagate the yi system from the bottom to the top of each layer (default: 100)'))
+        s += '{}\n'.format(fielddisplay(self, 'istemporal', ['1 for time-dependent love numbers, 0 for frequency-dependent or elastic love numbers (default: 0)', 'If 1: use fourierlove function build_frequencies_from_time to meet consistency']))
+        s += '{}\n'.format(fielddisplay(self, 'n_temporal_iterations', 'max number of iterations in the inverse Laplace transform. Also the number of spectral samples per time step requested (default: 8)'))
+        s += '{}\n'.format(fielddisplay(self, 'time', 'time vector for deformation if istemporal (default: 0) [s]'))
+        s += '{}\n'.format(fielddisplay(self, 'love_kernels', 'compute love numbers at depth? (default: 0)'))
+        s += '{}\n'.format(fielddisplay(self, 'forcing_type', 'integer indicating the nature and depth of the forcing for the Love number calculation (default: 11):'))
+        s += '{}\n'.format('                                                     1:  Inner core boundary -- Volumic Potential')
+        s += '{}\n'.format('                                                     2:  Inner core boundary --  Pressure')
+        s += '{}\n'.format('                                                     3:  Inner core boundary --  Loading')
+        s += '{}\n'.format('                                                     4:  Inner core boundary --  Tangential traction')
+        s += '{}\n'.format('                                                     5:  Core mantle boundary --  Volumic Potential')
+        s += '{}\n'.format('                                                     6:  Core mantle boundary --  Pressure')
+        s += '{}\n'.format('                                                     7:  Core mantle boundary --  Loading')
+        s += '{}\n'.format('                                                     8:  Core mantle boundary --  Tangential traction')
+        s += '{}\n'.format('                                                     9:  Surface--  Volumic Potential')
+        s += '{}\n'.format('                                                     10: Surface--  Pressure')
+        s += '{}\n'.format('                                                     11: Surface--  Loading')
+        s += '{}\n'.format('                                                     12: Surface--  Tangential traction ')
+        s += '{}\n'.format(fielddisplay(self, 'inner_core_boundary', 'interface index in materials.radius locating forcing. Only used for forcing_type 1--4 (default: 1)'))
+        s += '{}\n'.format(fielddisplay(self, 'core_mantle_boundary', 'interface index in materials.radius locating forcing. Only used for forcing_type 5--8 (default: 2)'))
 
-        return string
+        return s
     #}}}
 
-    def extrude(self, md):  # {{{
-        return self
+    def setdefaultparameters(self): #{{{
+        # We setup an elastic love number computation by default
+        self.nfreq = 1
+        self.frequencies = [0] # Hz
+        self.sh_nmax = 256 # .35 degree, 40 km at the equator
+        self.sh_nmin = 1
+        # Work on matlab script for computing g0 for given Earth's structure
+        self.g0 = 9.81 # m/s^2
+        self.r0 = 6371 * 1e3 # m
+        self.mu0 = 1e11 # Pa
+        self.Gravitational_Constant = 6.67259e-11 # m^3 kg^-1 s^-2
+        self.allow_layer_deletion = 1
+        self.underflow_tol = 1e-16 # Threshold of deep to surface love number ratio to trigger the deletion of layer
+        self.integration_steps_per_layer = 100
+        self.istemporal = 0
+        self.n_temporal_iterations = 8
+        self.time = [0] # s
+        self.love_kernels = 0
+        self.forcing_type = 11 # Surface loading
+        self.inner_core_boundary = 1
+        self.core_mantle_boundary = 2
+        self.complex_computation = 0
     #}}}
 
-    def setdefaultparameters(self):  # {{{
-        #we setup an elastic love number computation by default.
-        self.nfreq = 1
-        self.frequencies = [0]  #Hz
-        self.sh_nmax = 256  # .35 degree, 40 km at the equator.
-        self.sh_nmin = 1
-        self.g0 = 9.81 # m/s^2
-        self.r0 = 6371e3 #m
-        self.mu0 = 1e11 # Pa
-        self.allow_layer_deletion = 1
-        self.love_kernels = 0
-        self.forcing_type = 11
+    def checkconsistency(self, md, solution, analyses): #{{{
+        if 'LoveAnalysis' not in analyses:
+            return md
 
-        return self
+        md = checkfield(md, 'fieldname', 'love.nfreq', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.frequencies', 'NaN', 1, 'Inf', 1, 'numel', md.love.nfreq)
+        md = checkfield(md, 'fieldname', 'love.sh_nmax', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.sh_nmin', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.g0', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.r0', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.mu0', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.Gravitational_Constant', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.allow_layer_deletion', 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'love.underflow_tol', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.integration_steps_per_layer', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+        md = checkfield(md, 'fieldname', 'love.love_kernels', 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'love.forcing_type', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0, '<=', 12)
+        md = checkfield(md, 'fieldname', 'love.complex_computation', 'NaN', 1, 'Inf', 1, 'numel', 1, 'values', [0, 1])
+
+        md = checkfield(md, 'fieldname', 'love.istemporal', 'values', [0, 1])
+        if md.love.istemporal:
+            md = checkfield(md, 'fieldname', 'love.n_temporal_iterations', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0)
+            md = checkfield(md, 'fieldname', 'love.time', 'NaN', 1, 'Inf', 1, 'numel', md.love.nfreq / 2 / md.love.n_temporal_iterations)
+        if md.love.sh_nmin <= 1 and (md.love.forcing_type == 9 or md.love.forcing_type == 5 or md.love.forcing_type == 1):
+            raise RuntimeError('Degree 1 not supported for forcing type {}. Use sh_min >= 2 for this kind of calculation.'.format(md.love.forcing_type))
+
+        # Need 'litho' material
+        if not hasattr(md.materials, 'materials') or 'litho' not in md.materials.nature:
+            raise RuntimeError('Need a \'litho\' material to run a Fourier Love number analysis')
+
+        mat = np.where(np.array(nature) == 'litho')[0]
+        if md.love.forcing_type <= 4:
+            md = checkfield(md, 'fieldname', 'love.inner_core_boundary', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0, '<=', md.materials[mat].numlayers)
+        elif md.love.forcing_type <= 8:
+            md = checkfield(md, 'fieldname', 'love.core_mantle_boundary', 'NaN', 1, 'Inf', 1, 'numel', 1, '>', 0, '<=', md.materials[mat].numlayers)
+
+        return md
     #}}}
 
-    def checkconsistency(self, md, solution, analyses):  # {{{
-        md = checkfield(md, 'fieldname', 'love.nfreq', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.frequencies', 'NaN', 1, 'Inf', 1, 'numel', [md.love.nfreq])
-        md = checkfield(md, 'fieldname', 'love.sh_nmax', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.sh_nmin', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.g0', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.r0', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.mu0', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0)
-        md = checkfield(md, 'fieldname', 'love.allow_layer_deletion', 'values', [0, 1])
-        md = checkfield(md, 'fieldname', 'love.love_kernels', 'values', [0, 1])
-        md = checkfield(md, 'fieldname', 'love.forcing_type', 'NaN', 1, 'Inf', 1, 'numel', [1], '>', 0, '<=', 12)
-        if md.love.sh_nmin <= 1 and md.love.forcing_type == 9:
-            raise RuntimeError("Degree 1 not supported for Volumetric Potential forcing. Use sh_min >= 2 for this kind of calculation.")
-
-        return md
-    # }}}
-
-    def marshall(self, prefix, md, fid):  # {{{
+    def marshall(self, prefix, md, fid): #{{{
         WriteData(fid, prefix, 'object', self, 'fieldname', 'nfreq', 'format', 'Integer')
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'frequencies', 'format', 'DoubleMat', 'mattype', 3)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'frequencies', 'format', 'DoubleMat', 'mattype',3)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'sh_nmax', 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'sh_nmin', 'format', 'Integer')
@@ -100,6 +148,30 @@
         WriteData(fid, prefix, 'object', self, 'fieldname', 'r0', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'mu0', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'Gravitational_Constant', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'allow_layer_deletion', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'underflow_tol', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'integration_steps_per_layer', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'istemporal', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'n_temporal_iterations', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'complex_computation', 'format', 'Boolean')
+        # Note: no need to marshall the time vector, we have frequencies
         WriteData(fid, prefix, 'object', self, 'fieldname', 'love_kernels', 'format', 'Boolean')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'forcing_type', 'format', 'Integer')
-    # }}}
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'inner_core_boundary', 'format', 'Integer')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'core_mantle_boundary', 'format', 'Integer')
+    #}}}
+
+    def extrude(self, md): #{{{
+        return self
+    #}}}
+
+    def build_frequencies_from_time(self): #{{{
+        if not self.istemporal:
+            raise RuntimeError('cannot build frequencies for temporal love numbers if love.istemporal==0')
+        print('Temporal love numbers: Overriding md.love.nfreq and md.love.frequencies')
+        self.nfreq = len(self.time) * 2 * self.n_temporal_iterations
+        self.frequencies = np.zeros((self.nfreq, 1))
+        for i in range(len(self.time)):
+            for j in range(2 * self.n_temporal_iterations):
+                self.frequencies[(i - 1) * 2 * self.n_temporal_iterations + j] = j * np.log(2) / self.time[i] / 2 / np.pi
+    #}}}
Index: issm/trunk/src/m/classes/friction.js
===================================================================
--- issm/trunk/src/m/classes/friction.js	(revision 25994)
+++ issm/trunk/src/m/classes/friction.js	(revision 26744)
@@ -14,5 +14,7 @@
 		fielddisplay(this,'p','p exponent');
 		fielddisplay(this,'q','q exponent');
+		fielddisplay(this,'effective_pressure','Effective Pressure for the forcing if not coupled [Pa]');
 		fielddisplay(this,'coupling','Coupling flag: 0 for default, 1 for forcing(provide md.friction.effective_pressure)  and 2 for coupled(not implemented yet)');
+		fielddisplay(this,'effective_pressure_limit','Neff do not allow to fall below a certain limit: effective_pressure_limit*rho_ice*g*thickness (default 0)');
 	} // }}}
 	this.extrude = function(md) {//{{{
@@ -42,12 +44,13 @@
 				return; 
 			}
-			md = checkfield(md,'fieldname','friction.coefficient','timeseries',1,'NaN',1,'Inf',1);
-			md = checkfield(md,'fieldname','friction.q','NaN',1,'Inf',1,'size',[md.mesh.numberofelements ,1]);
-			md = checkfield(md,'fieldname','friction.p','NaN',1,'Inf',1,'size',[md.mesh.numberofelements ,1]);
-			md = checkfield(md,'fieldname','friction.coupling','numel',[1],'values',[0, 1, 2]);
+			checkfield(md,'fieldname','friction.coefficient','timeseries',1,'NaN',1,'Inf',1);
+			checkfield(md,'fieldname','friction.q','NaN',1,'Inf',1,'size',[md.mesh.numberofelements ,1]);
+			checkfield(md,'fieldname','friction.p','NaN',1,'Inf',1,'size',[md.mesh.numberofelements ,1]);
+			checkfield(md,'fieldname','friction.coupling','numel',[1],'values',[0, 1, 2]);
+			checkfield(md,'fieldname','friction.effective_pressure_limit','numel',[1],'>=',0);
 			switch (this.coupling) {
 				case 0:
 				case 1:
-					md = checkfield(md,'fieldname','friction.effective_pressure','NaN',1,'Inf',1,'timeseries',1);
+					checkfield(md,'fieldname','friction.effective_pressure','NaN',1,'Inf',1,'timeseries',1);
 					break;
 				case 2:
@@ -63,11 +66,20 @@
 
 			WriteData(fid,prefix,'name','md.friction.law','data',1,'format','Integer');
-			WriteData(fid,prefix,'object',this,'fieldname','coefficient','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			//WriteData(fid,prefix,'object',this,'fieldname','coefficient','format','DoubleMat','mattype',1);
+			let mattype,tsl;
+			if ((size(this.coefficient,0)==md.mesh.numberofvertices | size(this.coefficient,1)==md.mesh.numberofvertices+1)) {
+				mattype=1;
+				tsl = md.mesh.numberofvertices;
+			} else {
+				mattype=2;
+				tsl = md.mesh.numberofelements;
+			}
+			WriteData(fid,prefix,'object',this,'fieldname','coefficient','format','DoubleMat','mattype',mattype,'timeserieslength',tsl+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',this,'fieldname','p','format','DoubleMat','mattype',2);
 			WriteData(fid,prefix,'object',this,'fieldname','q','format','DoubleMat','mattype',2);
 			WriteData(fid,prefix,'class','friction','object',this,'fieldname','coupling','format','Integer');
+			WriteData(fid,prefix,'object',this,'class','friction','fieldname','effective_pressure_limit','format','Double');
 			switch (this.coupling) {
 				case 0:
+					break;
 				case 1:
 					WriteData(fid,prefix,'class','friction','object',this,'fieldname','effective_pressure','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
@@ -79,6 +91,4 @@
 					console.error('not supported yet');		
 			}
-			
-
 		}//}}}
 		this.fix=function() { //{{{
@@ -86,9 +96,10 @@
 	//properties 
 	//{{{
-	this.coefficient = NaN;
-	this.p           = NaN;
-	this.q           = NaN;
-	this.coupling    = 0;
-	this.effective_pressure = NaN;
+	this.coefficient			  = NaN;
+	this.p						  = NaN;
+	this.q						  = NaN;
+	this.coupling				  = 0;
+	this.effective_pressure 	  = NaN;
+	this.effective_pressure_limit = 0;
 	this.setdefaultparameters();
 	//}}}
Index: issm/trunk/src/m/classes/friction.m
===================================================================
--- issm/trunk/src/m/classes/friction.m	(revision 25994)
+++ issm/trunk/src/m/classes/friction.m	(revision 26744)
@@ -6,9 +6,9 @@
 classdef friction
 	properties (SetAccess=public) 
-		coefficient = NaN;
-		p           = NaN;
-		q           = NaN;
-		coupling    = 0;
-		effective_pressure = NaN;
+		coefficient              = NaN;
+		p                        = NaN;
+		q                        = NaN;
+		coupling                 = 0;
+		effective_pressure       = NaN;
 		effective_pressure_limit = 0;
 	end
@@ -18,14 +18,6 @@
 			self.p=project3d(md,'vector',self.p,'type','element');
 			self.q=project3d(md,'vector',self.q,'type','element');
-			switch self.coupling
-				case 0
-				case 1
-				case 2
-				case 3
-					self.effective_pressure=project3d(md,'vector',self.effective_pressure,'type','node','layer',1);
-				case 4
-					self.effective_pressure=project3d(md,'vector',self.effective_pressure,'type','node','layer',1);
-				otherwise
-					error('not supported yet');		
+			if self.coupling==3 || self.coupling==4
+				self.effective_pressure=project3d(md,'vector',self.effective_pressure,'type','node','layer',1);
 			end
 		end % }}}
@@ -57,14 +49,6 @@
 			md = checkfield(md,'fieldname','friction.coupling','numel',[1],'values',[0:4]);
 			md = checkfield(md,'fieldname','friction.effective_pressure_limit','numel',[1],'>=',0);
-			switch self.coupling
-				case 0
-				case 1
-				case 2
-				case 3
-					md = checkfield(md,'fieldname','friction.effective_pressure','NaN',1,'Inf',1,'timeseries',1);
-				case 4
-				
-				otherwise
-					error('not supported yet');
+         if self.coupling==3
+            md = checkfield(md,'fieldname','friction.effective_pressure','NaN',1,'Inf',1,'timeseries',1);
 			end
 		end % }}}
@@ -92,14 +76,6 @@
 			WriteData(fid,prefix,'class','friction','object',self,'fieldname','coupling','format','Integer');
 			WriteData(fid,prefix,'object',self,'class','friction','fieldname','effective_pressure_limit','format','Double');
-			switch self.coupling
-				case 0
-				case 1
-				case 2
-				case 3
-					WriteData(fid,prefix,'class','friction','object',self,'fieldname','effective_pressure','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-				case 4
-					WriteData(fid,prefix,'class','friction','object',self,'fieldname','effective_pressure','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-				otherwise
-					error('not supported yet');		
+			if self.coupling==3 || self.coupling==4
+				WriteData(fid,prefix,'class','friction','object',self,'fieldname','effective_pressure','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 			end
 		end % }}}
Index: issm/trunk/src/m/classes/friction.py
===================================================================
--- issm/trunk/src/m/classes/friction.py	(revision 25994)
+++ issm/trunk/src/m/classes/friction.py	(revision 26744)
@@ -23,5 +23,4 @@
         self.setdefaultparameters()
     #}}}
-
     def __repr__(self):  # {{{
         s = 'Basal shear stress parameters: Sigma_b = coefficient^2 * Neff ^r * |u_b|^(s - 1) * u_b,\n'
@@ -35,27 +34,20 @@
         return s
     #}}}
-
     def setdefaultparameters(self):  # {{{
         self.effective_pressure_limit = 0
         return self
     #}}}
-
     def extrude(self, md):  # {{{
         self.coefficient = project3d(md, 'vector', self.coefficient, 'type', 'node', 'layer', 1)
         self.p = project3d(md, 'vector', self.p, 'type', 'element')
         self.q = project3d(md, 'vector', self.q, 'type', 'element')
-        # If self.coupling == 0:  #doesnt work with empty loop, so just skip it?
         if self.coupling in[3, 4]:
             self.effective_pressure = project3d(md, 'vector', self.effective_pressure, 'type', 'node', 'layer', 1)
-        elif self.coupling > 4:
-            raise ValueError('md.friction.coupling larger than 4, not supported yet')
         return self
     #}}}
-
     def defaultoutputs(self, md):  # {{{
         list = []
         return list
     #}}}
-
     def checkconsistency(self, md, solution, analyses):  # {{{
         # Early return
@@ -71,9 +63,6 @@
         if self.coupling == 3:
             md = checkfield(md, 'fieldname', 'friction.effective_pressure', 'NaN', 1, 'Inf', 1, 'timeseries', 1)
-        elif self.coupling > 4:
-            raise ValueError('not supported yet')
         return md
     # }}}
-
     def marshall(self, prefix, md, fid):  # {{{
         WriteData(fid, prefix, 'name', 'md.friction.law', 'data', 1, 'format', 'Integer')
@@ -89,9 +78,5 @@
         WriteData(fid, prefix, 'class', 'friction', 'object', self, 'fieldname', 'coupling', 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'class', 'friction', 'fieldname', 'effective_pressure_limit', 'format', 'Double')
-        if self.coupling == 3:
+        if self.coupling == 3 or self.coupling == 4:
             WriteData(fid, prefix, 'class', 'friction', 'object', self, 'fieldname', 'effective_pressure', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
-        elif self.coupling == 4:
-            WriteData(fid, prefix, 'class', 'friction', 'object', self, 'fieldname', 'effective_pressure', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
-        elif self.coupling > 4:
-            raise ValueError('not supported yet')
     # }}}
Index: issm/trunk/src/m/classes/frictioncoulomb2.m
===================================================================
--- issm/trunk/src/m/classes/frictioncoulomb2.m	(revision 26744)
+++ issm/trunk/src/m/classes/frictioncoulomb2.m	(revision 26744)
@@ -0,0 +1,102 @@
+%FRICTIONCOULOMB2 class definition
+%
+%   Usage:
+%      frictioncoulomb=frictioncoulomb2();
+
+classdef frictioncoulomb2
+	properties (SetAccess=public) 
+		C                        = NaN;
+		m                        = NaN;
+		coupling                 = 0;
+		effective_pressure       = NaN;
+		effective_pressure_limit = 0;
+	end
+	methods (Static)
+		function self = loadobj(self) % {{{
+			if isstruct(self)
+				disp('Recovering frictioncoulomb2 from older version');
+				if isfield(self,'coefficient')
+					self.C = self.coefficient;
+				end
+				self = structtoobj(frictioncoulomb2(),self);
+			end
+		end% }}}
+	end
+	methods
+		function self = extrude(self,md) % {{{
+			self.C=project3d(md,'vector',self.C,'type','node','layer',1);
+			self.m=project3d(md,'vector',self.m,'type','element');
+			switch self.coupling
+				case 0
+				case 1
+					self.effective_pressure=project3d(md,'vector',self.effective_pressure,'type','node','layer',1);
+				case 2
+					error('not implemented yet');
+				otherwise
+					error('not supported yet');		
+			end
+		end % }}}
+		function self = frictioncoulomb(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+
+			self.effective_pressure_limit = 0;
+
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			%Early return
+			if ~ismember('StressbalanceAnalysis',analyses) & ~ismember('ThermalAnalysis',analyses), return; end
+			md = checkfield(md,'fieldname','friction.C','timeseries',1,'NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','friction.m','NaN',1,'Inf',1,'size',[md.mesh.numberofelements 1]);
+			md = checkfield(md,'fieldname','friction.coupling','numel',[1],'values',[0 1 2]);
+			md = checkfield(md,'fieldname','friction.effective_pressure_limit','numel',[1],'>=',0);			
+			switch self.coupling
+				case 0
+				case 1
+					md = checkfield(md,'fieldname','friction.effective_pressure','NaN',1,'Inf',1,'timeseries',1);
+				case 2
+					error('not implemented yet');
+				otherwise
+					error('not supported yet');		
+			end
+		end % }}}
+		function disp(self) % {{{
+         disp('Coulomb limited sliding law parameters:');
+         disp(' ');
+         disp('                     C^2 |u_b|^(m-1) * (.5*N)           ');
+         disp('      tau_b = - _________________________________   u_b ');
+         disp('                (C^(2/m) |u_b| + (0.5*N)^(1/m) )^m      ');
+         disp(' ');
+			fielddisplay(self,'C','friction coefficient [SI]');
+			fielddisplay(self,'m','m exponent (Weertman would be 1/3)');
+			fielddisplay(self,'effective_pressure','Effective Pressure for the forcing if not coupled [Pa]');
+			fielddisplay(self,'coupling','Coupling flag: 0 for default, 1 for forcing(provide md.friction.effective_pressure)  and 2 for coupled (not implemented yet)');
+			fielddisplay(self,'effective_pressure_limit','Neff do not allow to fall below a certain limit: effective_pressure_limit*rho_ice*g*thickness (default 0)');	
+			end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+
+			WriteData(fid,prefix,'name','md.friction.law','data',13,'format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','C','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'fieldname','m','format','DoubleMat','mattype',2);
+			WriteData(fid,prefix,'class','friction','object',self,'fieldname','coupling','format','Integer');
+			WriteData(fid,prefix,'object',self,'class','friction','fieldname','effective_pressure_limit','format','Double');
+			switch self.coupling
+				case 0
+				case 1
+					WriteData(fid,prefix,'class','friction','object',self,'fieldname','effective_pressure','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+				case 2
+					error('not implemented yet');
+				otherwise
+					error('not supported yet');		
+			end
+
+		end % }}}
+	end
+end
